@JS()
library script.js;

import 'package:flutter_web_plugins/flutter_web_plugins.dart';
import 'package:haptics/models/haptic_level.dart';
import 'package:js/js.dart';

@JS('pwm')
external dynamic _vibrate(double duration, double on, double off);

class HapticsWeb extends HapticsPlatform {
  static void registerWith(Registrar registrar) {
    var haptics = HapticsWeb();
    HapticsPlatform.instance = haptics;
  }

  @override
  void feedback(HapticLevel type) {
    double on = 30, off = 10, duration = 500;
    switch (type) {
      case HapticLevel.impact:
        _vibrate(duration, on, off);
        break;
      case HapticLevel.error:
        _vibrate(duration, on, off);

        break;
      case HapticLevel.success:
        _vibrate(duration, on, off);

        break;
      case HapticLevel.warning:
        _vibrate(duration, on, off);

        break;
      case HapticLevel.selection:
        _vibrate(duration, on, off);

        break;
      case HapticLevel.heavy:
        _vibrate(duration, on, off);

        break;
      case HapticLevel.medium:
        _vibrate(duration, on, off);

        break;
      case HapticLevel.light:
        _vibrate(duration, on, off);

        break;
      default:
    }
  }
}

abstract class HapticsPlatform {
  void feedback(HapticLevel type);
  static HapticsPlatform? instance;
}
